{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}

Unit Cpuinfo;

Interface

Type

  Tcpuinfo = Record
    Idstring : Array [0..11] Of Char;
    Stepping : LongInt;
    Model    : LongInt;
    Family   : LongInt;
    Fpu,
    Virtualmodeextensions,
    Debuggingextensions,
    Pagesizeextensions,
    Timestampcounter,
    K86Modelspecificregisters,
    Machinecheckexception,
    Cmpxchg8B,
    Apic,
    Memorytyperangeregisters,
    Globalpagingextension,
    Conditionalmoveinstruction,
    Mmx     : Boolean;
    Syscallandsysret,
    FPConditionalMoveInstruction,
    Amd3Dnow : Boolean;
    Cpuname : String;
  End;
  {ଠ  䨪樨 }
Function Existcpuid:Boolean;
Function Cpuidinfo(Var Info: Tcpuinfo):Boolean;
{-  孮 }
Function Existmmx:Boolean;
Function Exist3Dnow:Boolean;
Function Existkni:Boolean;
{------------------------}
Procedure Emms;
Procedure Femms;
Procedure Prefetch(P: Pointer);

Implementation

Function Existcpuid : Boolean;
Asm
  Pushfd
  Pop Eax
  Mov Ebx, Eax
  XOr Eax, 00200000H
  Push Eax
  Popfd
  Pushfd
  Pop Ecx
  Mov Eax,0
  Cmp Ecx, Ebx
  Jz @No_Cpuid
  Inc Eax
  @No_Cpuid:
End;

Function Cpuidinfo(Var Info: Tcpuinfo):Boolean;

Function ExistExtendedCPUIDFunctions:Boolean;
Asm
  Mov Eax,080000000H
  Db $0F,$A2
End;
Var

  Name : Array [0..47] Of Char;
  P : Pointer;
Begin
  If Existcpuid Then Asm
    Jmp @Start
    @Bitloop:
    Mov AL,DL
    And AL,1
    Mov [Edi],AL
    ShR Edx,1
    Inc Edi
    Loop @Bitloop
    Ret
    @Start:
    Mov Edi,Info
    Mov Eax,0
    Db $0F,$A2
    Mov [Edi],Ebx
    Mov [Edi+4],Edx
    Mov [Edi+8],Ecx
    Mov Eax,1
    Db $0F,$A2
    Mov Ebx,Eax
    And Eax,0Fh;
    Mov [Edi+12],Eax;
    ShR Ebx,4
    Mov Eax,Ebx
    And Eax,0Fh
    Mov [Edi+12+4],Eax
    ShR Ebx,4
Mov Eax,Ebx
And Eax,0Fh
Mov [Edi+12+8],Eax
Add Edi,24
Mov Ecx,6
Call @Bitloop
ShR Edx,1
Mov Ecx,3
Call @Bitloop
ShR Edx,2
Mov Ecx,2
Call @Bitloop
ShR Edx,1
Mov Ecx,1
Call @Bitloop
ShR Edx,7
Mov Ecx,1
Call @Bitloop
Mov P,Edi
End;
If (Info.Idstring = 'AuthenticAMD') And ExistExtendedCPUIDFunctions Then Begin
  Asm
    Mov Edi,P
    Mov Eax,080000001H
    Db $0F,$A2
    Mov Eax,Edx
    ShR Eax,11
    And AL,1
    Mov [Edi],AL
    Mov Eax,Edx
    ShR Eax,16
    And AL,1
    Mov [Edi+1],AL
    Mov Eax,Edx
    ShR Eax,31
    And AL,1
    Mov [Edi+2],AL
    Lea Edi,Name
    Mov Eax,0
    Mov [Edi],Eax
    Mov Eax,080000000H
    Db $0F,$A2
    Cmp Eax,080000004H
    Jl @Nostring
    Mov Eax,080000002H
    Db $0F,$A2
    Mov [Edi],Eax
    Mov [Edi+4],Ebx
    Mov [Edi+8],Ecx
    Mov [Edi+12],Edx
    Add Edi,16
    Mov Eax,080000003H
    Db $0F,$A2
    Mov [Edi],Eax
    Mov [Edi+4],Ebx
    Mov [Edi+8],Ecx
    Mov [Edi+12],Edx
    Add Edi,16
    Mov Eax,080000004H
    Db $0F,$A2
    Mov [Edi],Eax
    Mov [Edi+4],Ebx
    Mov [Edi+8],Ecx
    Mov [Edi+12],Edx
    @Nostring:
  End;
  Info.Cpuname:=Name;
End Else With Info Do Begin
  Syscallandsysret:=False;
  FPConditionalMoveInstruction:=False;
  Amd3Dnow:=False;
  Cpuname:='';
End;
{Result:=ExistCPUID;}
Cpuidinfo:=Existcpuid;
End;

Function Existmmx:Boolean;
Var

  Info : Tcpuinfo;
Begin

  If Cpuidinfo(Info) Then
    Result:=Info.Mmx
  Else
    Result:=False;
End;

Function Exist3Dnow:Boolean;
Var

  Info : Tcpuinfo;
Begin

  If Cpuidinfo(Info) Then
    Result:=Info.Amd3Dnow
  Else
    Result:=False;
  End;

Function Existkni:Boolean;
Begin

  Result:=False;
End;

Procedure Emms;
Asm

  Db $0F,$77
End;

Procedure Femms;
Asm

  Db $0F,$03
End;

Procedure Prefetch(P: Pointer);
Asm

  // Prefetch Byte Ptr [Eax]
End;

End.